;==========================================================================================================================================================
; 
;==========================================================================================================================================================
; Title: Font Preview ComboBox
; Author: Fluid Byte
; Created: January 26, 2009
; Updated: January 27, 2009
; Test-Platform: Windows XP SP3

;EnableExplicit

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

Declare WindowCallback(hWnd, uMsg, wParam, lParam)
Declare EnumFontsProc(*lpelfe.ENUMLOGFONTEX, *lpntme.NEWTEXTMETRICEX, FontType, lParam)
Declare EnumFonts(Gadget)

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

Structure FONTDATA
   Type.b
   Symbol.b
   Name.s
EndStructure

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

Global NewList ftd.FONTDATA(), himlFontType

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

UseJCALG1Packer()

Define *lpBuffer

;==========================================================================================================================================================
; Load packed image from memory
;==========================================================================================================================================================

*lpBuffer = AllocateMemory(406)

UncompressMemory(?FontType, ?FontTypeEnd - ?FontType, *lpBuffer, MemorySize(*lpBuffer), #PB_PackerPlugin_JCALG1)

CatchImage(0, *lpBuffer)

FreeMemory(*lpBuffer)

;==========================================================================================================================================================
; Create ImageList
;==========================================================================================================================================================

himlFontType = ImageList_Create_(16, 12, #ILC_MASK, 0, 0)

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

ImageList_AddMasked_(himlFontType, ImageID(0), #Yellow)

;==========================================================================================================================================================
; Functions
;==========================================================================================================================================================

Procedure WindowCallback(hWnd, uMsg, wParam, lParam)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ReturnValue.i = #PB_ProcessPureBasicEvents
  
  ;------------------------------------------------------------------------------------------------
  ; NetMaestro's ScreenSnap
  ;------------------------------------------------------------------------------------------------
  
  Static snapped1, snapped2, snapped3, snapped4
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  Select uMsg
      
  ;------------------------------------------------------------------------------------------------
  ; RASHAD's background colour support for static controls
  ;------------------------------------------------------------------------------------------------
    
  Case  #WM_CTLCOLORSTATIC, #WM_CTLCOLOREDIT, #WM_CTLCOLORLISTBOX
    
    Select GetProp_(lParam, "PB_ID")
        
      Case #Gadget_Search_matchcase,  #Gadget_Search_SearchUp,  #Gadget_Search_SearchDown
        
        SetBkMode_(wParam,    #TRANSPARENT)
        
        SetTextColor_(wParam, #Black)
        
        ReturnValue.i = Program\StaticBack
        
    EndSelect

    ;----------------------------------------------------------------------------------------------
    ; Netmaestro's windowsnap code
    ;----------------------------------------------------------------------------------------------
    
  Case #WM_MOVING
    
    If Program\ScreenSnap = 1
      
      *view.RECT = lparam
      
      curwidth  = *view\right - *view\left
      
      curheight = *view\bottom - *view\top
      
      If AutoSnap                                                                         ;  AutoSnap Section
        
        If *view\left < SnapD
          
          If Not Snapped1
            
            *view\left = 0
            
            *view\right = curwidth
            
            snapped1 = #True
            
            ReturnValue = #True
            
          EndIf
          
        Else
          
          snapped1 = #False
          
        EndIf
        
        If *view\top < SnapD
          
          If Not Snapped2
            
            *view\top = 0
            
            *view\bottom = curheight
            
            snapped2 = #True
            
            ReturnValue = #True
            
          EndIf
          
        Else
          
          snapped2 = #False
          
        EndIf
        
        If *view\right > screenw - SnapD
          
          If Not Snapped3
            
            *view\left  = ScreenW - curwidth
            
            *view\right = screenW
            
            snapped3 = #True
            
            ReturnValue = #True
            
          EndIf
          
        Else
          
          snapped3 = #False
          
        EndIf     
        
        If *view\bottom > screenH - SnapD
          
          If Not Snapped4
            
            *view\top = screenH - curheight
            
            *view\bottom = screenH
            
            snapped4 = #True
            
            ReturnValue = #True
            
          EndIf
          
        Else
          
          snapped4 = #False
          
        EndIf     
        
      EndIf
      
      If *view\top < 0                                                                    ;  Inside Desktop Section
        
        *view\top = 0
        
        *view\bottom = curheight
        
      EndIf
      
      If *view\left < 0 
        
        *view\left = 0
        
        *view\right = curwidth
        
      EndIf
      
      If *view\right > screenW
        
        *view\right = screenW
        
        *view\left = *view\right - curwidth
        
      EndIf
      
      If *view\bottom > screenH
        
        *view\bottom = screenH
        
        *view\top = *view\bottom - curheight
        
      EndIf
      
      MoveWindow_(WindowID, *view\left, *view\top, *view\right - *view\left, *view\bottom - *view\top, #True)
      
      ReturnValue = #True
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; Sparkie/Srod's addition to detect pos in editorgadget and convert to physical line
    ;----------------------------------------------------------------------------------------------
    
  Case #WM_NOTIFY
    
    *nmhdr.NMHDR = lParam
    
    Select *nmhdr\code
        
      Case #EN_MSGFILTER
        
        *msgf.MSGFILTER = lParam
        
        If *msgf\msg = #WM_RBUTTONDOWN
          
          ;           Debug "Right button pressed"
          
        EndIf
        
        If *msgf\msg = #WM_LBUTTONDOWN
          
          clickX = *msgf\lParam &$FFFF
          
          clickY = *msgf\lParam >>16 &$FFFF
          
          ;            SetGadgetText(1, "Left button Down at x: " + Str(clickX) + "   y: " + Str(clickY))
          
          pt.POINT\x  = clickX
          
          pt\y        = clickY
          
          pos         =       SendMessage_(*nmhdr\hWndFrom, #EM_CHARFROMPOS,     0, pt)
          
          line        =       SendMessage_(*nmhdr\hWndFrom, #EM_LINEFROMCHAR,  pos,  0)
          
          char        = pos - SendMessage_(*nmhdr\hWndFrom, #EM_LINEINDEX,    line,  0)
          
          ;           Debug "Line index = " + Str(line) + ", character index = " + Str(char)
          
        ElseIf *msgf\msg = #WM_LBUTTONUP
          
          clickX = *msgf\lParam &$FFFF
          
          clickY = *msgf\lParam >>16 &$FFFF
          
          ;             SetGadgetText(1, "Left button Up at x: " + Str(clickX) + "   y: " + Str(clickY))
          
            ;--------------------------------------------------------------------------------------
            ; Get the selection text's font name.
            ;--------------------------------------------------------------------------------------
            
            cf2.CHARFORMAT2\cbsize = SizeOf(CHARFORMAT2)
            
            SendMessage_(GadgetID(#Gadget_notepiddle_edit), #EM_GETCHARFORMAT ,#SCF_SELECTION, @cf2)
            
            If cf2
              
              ;------------------------------------------------------------------------------------
              ; Highlight the current font used in the font gadget when an item is clicked on
              ;------------------------------------------------------------------------------------
              
              FaceName.s = PeekS(@cf2\szFaceName)
              
              ForEach ftd()
                
                If ftd()\Name = FaceName
                  
                  SetGadgetState(#Gadget_notepiddle_font, ListIndex(ftd()))
                  
                EndIf
                
              Next
              
              ;------------------------------------------------------------------------------------
              ; Get the font size. Something is still wrong here, 1 pixel out
              ;------------------------------------------------------------------------------------
              
              PointSize = Round(cf2\yHeight/20, #PB_Round_Nearest)
              
              line = CountGadgetItems(#Gadget_notepiddle_size) - 1
              
              For pos = 0 To line
                
                If Val(GetGadgetItemText(#Gadget_notepiddle_size, pos)) = PointSize
                  
                  SetGadgetState(#Gadget_notepiddle_size, pos)
                  
                  Break
                  
                EndIf
                
              Next pos
              
              ;------------------------------------------------------------------------------------
              ; Get the style of the current font
              ;------------------------------------------------------------------------------------
              
              cf2\dwMask = #CFM_ITALIC|#CFM_BOLD|#CFM_STRIKEOUT|#CFM_UNDERLINE|#CFM_LINK|#CFM_SUBSCRIPT|#CFM_SUPERSCRIPT
              
              If cf2\dwEffects &#CFM_BOLD
                
                FaceStyle.s = "Bold"
                
                ; "100"
                
                SetGadgetState(#Gadget_notepiddle_bold, 1)
                
              Else
                
                SetGadgetState(#Gadget_notepiddle_bold, 0)
                
              EndIf
              
              If cf2\dwEffects &#CFM_ITALIC
                
                If FaceStyle
                  
                  FaceStyle + " + Italic"
                  
                Else
                  
                  FaceStyle = "Italic"
                  
                EndIf
                
                SetGadgetState(#Gadget_notepiddle_italic, 1)
                
              Else
                
                SetGadgetState(#Gadget_notepiddle_italic, 0)
                
              EndIf
              
              If cf2\dwEffects &#CFM_UNDERLINE
                
                If FaceStyle
                  
                  FaceStyle + " + Underline"
                  
                Else
                  
                  FaceStyle = "Underline"
                  
                EndIf
                
                SetGadgetState(#Gadget_notepiddle_underline, 1)
                
              Else
                
                SetGadgetState(#Gadget_notepiddle_underline, 0)
                
              EndIf
              
              If Len(FaceStyle) = 0
                
                FaceStyle = "Normal"
                
              EndIf
              
              ;------------------------------------------------------------------------------------
              ; Tell the user what font, size and style is being used
              ;------------------------------------------------------------------------------------
              
              SetStatusBar(1, "Font name: " + FaceName.s + " Size: " + Str(PointSize) + " Style: " + FaceStyle.s)
              
            EndIf
            
          EndIf
          
      EndSelect
      
      ;--------------------------------------------------------------------------------------------
      ; FluidByte's part of the callback for his routines
      ;--------------------------------------------------------------------------------------------
      
    Case #WM_DRAWITEM;, #WM_MEASUREITEM
      
      Protected *lpdis.DRAWITEMSTRUCT = lParam
      
      If *lpdis\hwndItem = GadgetID(#Gadget_notepiddle_font)                                 
        
        If *lpdis\itemState & #ODS_SELECTED
          
          Protected hbrFocus = CreateSolidBrush_(GetSysColor_(#COLOR_HIGHLIGHT))
          
          FillRect_(*lpdis\hDC,*lpdis\rcItem,hbrFocus)
          
          DeleteObject_(hbrFocus)
          
          DrawFocusRect_(*lpdis\hDC,*lpdis\rcItem)            
          
          SetTextColor_(*lpdis\hDC,GetSysColor_(#COLOR_HIGHLIGHTTEXT))
          
        Else
          
          Protected hbrFace = CreateSolidBrush_(GetSysColor_(#COLOR_WINDOW))
          
          FillRect_(*lpdis\hDC,*lpdis\rcItem,hbrFace)
          
          DeleteObject_(hbrFace)
          
          SetTextColor_(*lpdis\hDC,GetSysColor_(#COLOR_WINDOWTEXT))      
          
        EndIf   
        
        Protected *ftd.FONTDATA = GetGadgetItemData(#Gadget_notepiddle_font,*lpdis\itemID)         
        
        ; * Create Preview Font
        
        Protected lplf.LOGFONT, hfntPreview
        
        lplf\lfHeight = -MulDiv_(11,GetDeviceCaps_(*lpdis\hDC,#LOGPIXELSY),72)
        
        If *ftd\Symbol
          
          lplf\lfCharSet = #SYMBOL_CHARSET
          
        EndIf
        
        PokeS(@lplf\lfFaceName,GetGadgetItemText(#Gadget_notepiddle_font,*lpdis\itemID))
        
        hfntPreview = CreateFontIndirect_(lplf)
        
        ; * Draw Font Icons
        
        If *ftd\Type > -1
          
          ImageList_Draw_(himlFontType,*ftd\Type,*lpdis\hDC,2,*lpdis\rcItem\top + 3,#ILD_TRANSPARENT)
          
        EndIf
        
        ; * Draw Preview Text
        
        SetBkMode_(*lpdis\hDC,#TRANSPARENT)   
        
        If *ftd\Symbol
          
          Protected fsz.SIZE
          
          *lpdis\rcItem\left + 20
          
          SelectObject_(*lpdis\hDC,GetStockObject_(#DEFAULT_GUI_FONT))
          
          GetTextExtentPoint32_(*lpdis\hDC,*ftd\Name,Len(*ftd\Name),fsz)
          
          DrawText_(*lpdis\hDC,*ftd\Name,-1,*lpdis\rcItem,#DT_SINGLELINE | #DT_VCENTER)   
          
          *lpdis\rcItem\left + fsz\cx + 3
          
          SelectObject_(*lpdis\hDC,hfntPreview)
          
          DrawText_(*lpdis\hDC,"ABC123",6,*lpdis\rcItem,#DT_SINGLELINE | #DT_VCENTER)
          
        Else
          
          *lpdis\rcItem\left + 20
          
          SelectObject_(*lpdis\hDC,hfntPreview)
          
          DrawText_(*lpdis\hDC,*ftd\Name,-1,*lpdis\rcItem,#DT_SINGLELINE | #DT_VCENTER)
          
        EndIf   
        
        DeleteObject_(hfntPreview)
        
      EndIf
      
      ProcedureReturn #True
      
  EndSelect
  
  ProcedureReturn #PB_ProcessPureBasicEvents
  
EndProcedure

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

Procedure EnumFontsProc(*lpelfe.ENUMLOGFONTEX,*lpntme.NEWTEXTMETRICEX,FontType,lParam)
  
  Protected CHRSET = *lpelfe\elfLogFont\lfCharSet & 255
  
  ; WESTERN FONTS / SYSTEM FONTS / SYMBOL FONTS
  
  If CHRSET = #ANSI_CHARSET Or CHRSET = #OEM_CHARSET Or CHRSET = #SYMBOL_CHARSET
    
    AddElement(ftd())
    
    Select FontType
        
      Case #TRUETYPE_FONTTYPE : ftd()\Type = 0
        
      Case #DEVICE_FONTTYPE   : ftd()\Type = 1
        
      Case #RASTER_FONTTYPE   : ftd()\Type = 2
        
      Default : ftd()\Type = -1
        
    EndSelect
    
    If CHRSET = #SYMBOL_CHARSET : ftd()\Symbol = 1 : EndIf
    
      ; Using 'lfFaceName' of the LOGFONT structure gives unique fontnames and avoids dublicates.
      ; When using 'elfFullName' of the ENUMLOGFONTEX structure you still can get dublicates even
      ; though you limit the character set like above. Also you don't need to cycle through the
      ; whole LinkedList everytime to find out if a fontname already exists.
      ; The created fontlist SHOULD be identical to the one in MS Wordpad + bitmap fonts (Courier, etc.)
      
      ftd()\Name = PeekS(@*lpelfe\elfLogFont\lfFaceName)
      
    EndIf
    
    ProcedureReturn #True
    
EndProcedure

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

Procedure EnumFonts(Gadget)
  
  Protected lplf.LOGFONT, hdc, Index
  
  lplf\lfCharset = #DEFAULT_CHARSET
  
  hdc = GetDC_(0)
  
  EnumFontFamiliesEx_(hdc,lplf,@EnumFontsProc(),hdc,0)
  
  ReleaseDC_(0,hdc)
  
  SortStructuredList(ftd(),#PB_Sort_Ascending,OffsetOf(FONTDATA\Name),#PB_String)
  
  ForEach ftd()
    
    If Left(ftd()\Name, 1) = "@"
      
      DeleteElement(ftd())
      
    Else
      
      AddGadgetItem(Gadget, -1, ftd()\Name)
      
      SetGadgetItemData(Gadget, Index, ftd())
      
      Index + 1
      
    EndIf
    
  Next
  
EndProcedure

;==========================================================================================================================================================
; Data section
;==========================================================================================================================================================

DataSection
   FontType:
   Data.l $0196434A,$3E3F0000,$A9B9266D,$146B20D0,$CA126809,$0C48B008,$80C79825,$09801720,$00782062,$60707CC0
   Data.l $38050812,$08090281,$0F017800,$0E003FF0,$00AE024C,$6AA85027,$E2EFEC01,$96E700CE,$A65C7B48,$80BC3260
   Data.l $88C3BB00,$77324AE1,$4EF262C0,$B80E4B2E,$8062C31D,$4A6DC296,$5980BDDE,$2257F369,$26DC1186,$83236C5A
   Data.l $2C35A0A3,$A5E71821,$7654AD10,$05A6360C,$4155AB69,$1809D849,$A3029E26,$30C111BD,$ED52A892,$C1125BAA
   Data.l $15C6B842,$0C0DCC50,$0EC21B6C,$48A08103,$36D81083,$64D9928C,$30C5786D,$2EDAE406,$280CBC8C,$178CD766
   Data.l $B79164B0,$830B3013,$301297BC,$1820604C,$4480C3DA,$00000042
   Data.b $00,$00
   FontTypeEnd:
EndDataSection
; IDE Options = PureBasic 5.23 LTS (Windows - x86)
; CursorPosition = 17
; FirstLine = 8
; Folding = -
; EnableAsm
; EnableXP
; CompileSourceDirectory