;============================================================================================================================================================
; Open the text search window
;============================================================================================================================================================

Procedure OpenSearchWindow()

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If CountGadgetItems(#Gadget_notepiddle_edit) <> 0
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If Window_Search()
  
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      StickyWindow(#Window_Search, #True)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      AddKeyboardShortcut(#Window_Search, #PB_Shortcut_Return,  #Shortcut_Search_SearchFirst)
      
      AddKeyboardShortcut(#Window_Search, #PB_Shortcut_F3,      #Shortcut_Search_SearchNext)
      
      AddKeyboardShortcut(#Window_Search, #PB_Shortcut_Escape,  #Shortcut_Search_escape)
      
      ;--------------------------------------------------------------------------------------------
      ; Remove theme support for certain gadgets where colours don't seem to work in PureBasic. This is
      ; as there is no crossplatform colour support for these controls
      ;--------------------------------------------------------------------------------------------
      
      SetWindowTheme_(GadgetID(#Gadget_Search_matchcase),   @null.w, @null.w)
      
      SetWindowTheme_(GadgetID(#Gadget_Search_SearchUp),    @null.w, @null.w)
      
      SetWindowTheme_(GadgetID(#Gadget_Search_SearchDown),  @null.w, @null.w)
      
      ;--------------------------------------------------------------------------------------------
      ; Limit the number of search box characters and set the cue banner text. These variables are set
      ; in the AppointmentMuncher_Myconstants file.
      ;--------------------------------------------------------------------------------------------
      
      SendMessage_(GadgetID(#Gadget_Search_Search), #EM_SETLIMITTEXT, 67, 0)
      
      SendMessage_(GadgetID(#Gadget_Search_Search), #EM_SETCUEBANNER,  1,  Program\SearchCueText)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetState(#Gadget_Search_SearchDown, 1)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      FadeInMyWindow(#Window_Search, 10)
    
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
    
      SetActiveGadget(#Gadget_Search_Search)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
    
      SetStatusBar(2, "Could not open the text searching window")
    
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
  
    SetStatusBar(2, "Nothing to search in, add some text first")
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.23 LTS (Windows - x86)
; CursorPosition = 22
; FirstLine = 24
; Folding = -
; EnableAsm
; EnableXP