;==============================================================================================================
; Title: Font Preview ComboBox, Author: Fluid Byte, Created: January 26, 2009, Tested with: Windows XP SP3
;==============================================================================================================

;EnableExplicit

;==============================================================================================================
; 
;==============================================================================================================

Declare WindowCallback(hWnd, uMsg, wParam, lParam)
Declare EnumFontsProc(*lpelfe.ENUMLOGFONTEX, *lpntme.NEWTEXTMETRICEX, FontType, lParam)
Declare EnumFonts()

;==============================================================================================================
; 
;==============================================================================================================

Structure FONTDATA
   Type.b
   Name.s
   Handle.l
EndStructure

;==============================================================================================================
; 
;==============================================================================================================

Global NewList ftd.FONTDATA()

;==============================================================================================================
; 
;==============================================================================================================

Global himlFontType = ImageList_Create_(16, 12, #ILC_MASK, 0, 0)

;==============================================================================================================
; 
;==============================================================================================================

Define lpBuffer,  EventID,  Quit

;==============================================================================================================
; 
;==============================================================================================================

lpBuffer = AllocateMemory(226)

UnpackMemory(?FontType, lpBuffer)

CatchImage(0, lpBuffer)

FreeMemory(lpBuffer)

;==============================================================================================================
; 
;==============================================================================================================

ImageList_AddMasked_(himlFontType, ImageID(0), #Yellow)

;==============================================================================================================
; FUNCTIONS
;==============================================================================================================

Procedure WindowCallback(hWnd, uMsg, wParam, lParam)
  Select uMsg
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------

    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    Case #WM_DRAWITEM
      Protected *lpdis.DRAWITEMSTRUCT = lParam
      If *lpdis\hwndItem = GadgetID(#Gadget_notepiddle_font)                                 
        If *lpdis\itemState & #ODS_SELECTED
          Protected hbrFocus = CreateSolidBrush_(GetSysColor_(#COLOR_HIGHLIGHT))
          FillRect_(*lpdis\hDC, *lpdis\rcItem, hbrFocus)
          DeleteObject_(hbrFocus)
          DrawFocusRect_(*lpdis\hDC, *lpdis\rcItem)            
          SetTextColor_(*lpdis\hDC, GetSysColor_(#COLOR_HIGHLIGHTTEXT))
        Else
          Protected hbrFace = CreateSolidBrush_(GetSysColor_(#COLOR_WINDOW))
          FillRect_(*lpdis\hDC, *lpdis\rcItem, hbrFace)
          DeleteObject_(hbrFace)
          SetTextColor_(*lpdis\hDC, GetSysColor_(#COLOR_WINDOWTEXT))      
        EndIf   
        Protected *fnt.FONTDATA = GetGadgetItemData(#Gadget_notepiddle_font, *lpdis\itemID)   
        If *fnt\Type > -1
          ImageList_Draw_(himlFontType, *fnt\Type, *lpdis\hDC, 2, *lpdis\rcItem\top + 3, #ILD_TRANSPARENT)
        EndIf
        SetBkMode_(*lpdis\hDC, #TRANSPARENT)
        SelectObject_(*lpdis\hDC, *fnt\Handle)            
        TextOut_(*lpdis\hDC, 20, *lpdis\rcItem\top, *fnt\Name, Len(*fnt\Name))         
      EndIf
      ProcedureReturn #True
      ;----------------------------------------------------------------------------------------------
      ; 
      ;----------------------------------------------------------------------------------------------
  EndSelect
  ProcedureReturn #PB_ProcessPureBasicEvents
EndProcedure

;==============================================================================================================
; 
;==============================================================================================================

Procedure EnumFontsProc(*lpelfe.ENUMLOGFONTEX, *lpntme.NEWTEXTMETRICEX, FontType, lParam)
  Protected CHRSET = *lpelfe\elfLogFont\lfCharSet & 255,  lplf.LOGFONT
  ; WESTERN FONTS / SYSTEM FONTS / SYMBOL FONTS
  If CHRSET = #ANSI_CHARSET Or CHRSET = #OEM_CHARSET Or CHRSET = #SYMBOL_CHARSET
    AddElement(ftd())
    Select FontType
      Case #TRUETYPE_FONTTYPE : ftd()\Type = 0
      Case #DEVICE_FONTTYPE : ftd()\Type = 1
      Case #RASTER_FONTTYPE : ftd()\Type = 2
      Default : ftd()\Type = -1
    EndSelect
    ; Using 'lfFaceName' of the LOGFONT structure gives unique fontnames and avoids dublicates.
    ; When using 'elfFullName' of the ENUMLOGFONTEX structure you still can get dublicates even
    ; though you limit the character set like above. Also you don't need to cycle through the
    ; whole LinkedList everytime to find out if a fontname already exists.
    ;
    ; The created fontlist is identical to the one in MS Wordpad + bitmap fonts (Courier,  etc.)
    ftd()\Name = PeekS(@*lpelfe\elfLogFont\lfFaceName)
    lplf\lfHeight = -MulDiv_(11, GetDeviceCaps_(lParam, #LOGPIXELSY), 72);
    PokeS(@lplf\lfFaceName, ftd()\Name)
    ftd()\Handle = CreateFontIndirect_(lplf)       
  EndIf
  ProcedureReturn #True
EndProcedure

;==============================================================================================================
; Enumerate the fonts. Gadget is hardcoded at this point but could be passed as well
;==============================================================================================================

Procedure EnumFonts()
  Protected lplf.LOGFONT,  hdc,  Index
  lplf\lfCharset = #DEFAULT_CHARSET
  hdc = GetDC_(0)
  EnumFontFamiliesEx_(hdc, lplf, @EnumFontsProc(), hdc, 0)
  ReleaseDC_(0, hdc)
  SortStructuredList(ftd(), #PB_Sort_Ascending, OffsetOf(FONTDATA\Name), #PB_Sort_String)
  ForEach ftd()
    AddGadgetItem(#Gadget_notepiddle_font, -1, "")
    SetGadgetItemData(#Gadget_notepiddle_font, Index, ftd())
    Index + 1
  Next
EndProcedure

;==============================================================================================================
; 
;==============================================================================================================

DataSection
   FontType:
   Data.l $0196434A, $3E3F0000, $A9B9266D, $146B20D0, $CA126809, $0C48B008, $80C79825, $09801720, $00782062, $60707CC0
   Data.l $38050812, $08090281, $0F017800, $0E003FF0, $00AE024C, $6AA85027, $E2EFEC01, $96E700CE, $A65C7B48, $80BC3260
   Data.l $88C3BB00, $77324AE1, $4EF262C0, $B80E4B2E, $8062C31D, $4A6DC296, $5980BDDE, $2257F369, $26DC1186, $83236C5A
   Data.l $2C35A0A3, $A5E71821, $7654AD10, $05A6360C, $4155AB69, $1809D849, $A3029E26, $30C111BD, $ED52A892, $C1125BAA
   Data.l $15C6B842, $0C0DCC50, $0EC21B6C, $48A08103, $36D81083, $64D9928C, $30C5786D, $2EDAE406, $280CBC8C, $178CD766
   Data.l $B79164B0, $830B3013, $301297BC, $1820604C, $4480C3DA, $00000042
   Data.b $00, $00
EndDataSection

;============================================================================================================================
; 
;============================================================================================================================

;DisableExplicit 


; IDE Options = PureBasic 4.30 (Windows - x86)
; CursorPosition = 70
; FirstLine = 64
; EnableAsm
; EnableXP